.386
.model flat,stdcall
option casemap:none

include     \masm32\include\windows.inc
include     \masm32\include\kernel32.inc
include     \masm32\include\user32.inc
include     \masm32\include\masm32.inc
include     \masm32\include\msvcrt.inc

include     \masm32\include\advapi32.inc
include     \masm32\macros\macros.asm

includelib  \masm32\lib\kernel32.lib
includelib  \masm32\lib\user32.lib
includelib  \masm32\lib\masm32.lib
includelib  \masm32\lib\advapi32.lib
includelib  \masm32\lib\msvcrt.lib

GetPrivileges   PROTO
SearchDir       PROTO :DWORD,:DWORD
UniStrLen       PROTO :DWORD
__wgetmainargs  PROTO C :VARARG


MEM_SIZE        equ 10240


.data

SE_SECURITY_NAME_ db 'SeSecurityPrivilege',0

msg1        db 'NTFS permission saver',13,10
            db 'Version 0.90 by Vortex',13,10,13,10
            db 'Usage : saveperm.exe drive \ folder filename.ext',13,10,0
msg2        db 'CreateFileW failure',0
msg3        db 'WriteFile failure',0
msg4        db 'Memory allocation failure',0
msg5        db 'Privilege request failure',0
ExitSearch  dd 0
flag1       dd 0
drv         dd 0
bWildCard   dd 0
WSTR        format1,"%s : GetFileSecurityW failure"


.data?

dwArgC      dd ?
pArgV       dd ?
pEnv        dd ?
hFile       dd ?
actualsize  dd ?
bWritten    dd ?
hMem        dd ?
tmp         dd ?
StartInfo   STARTUPINFO <?>
buffer      db 4+2*MAX_PATH dup(?)

.code

start:

    invoke  __wgetmainargs,ADDR dwArgC,ADDR pArgV,ADDR pEnv,\
            bWildCard,ADDR StartInfo

    cmp     dwArgC,3
    je      @f

    invoke  StdOut,ADDR msg1
    invoke  ExitProcess,0 
@@:
    invoke  GetPrivileges
    test    eax,eax
    jnz     @f

    invoke  StdOut,ADDR msg5
    invoke  ExitProcess,0    
@@:
    mov     eax,pArgV

    invoke  ucCopy,DWORD PTR [eax+4],\      ; src
            ADDR buffer                     ; dest

    mov     edx,pArgV
    
    invoke  CreateFileW,DWORD PTR [edx+8],\
            GENERIC_WRITE,0,0,\
            CREATE_ALWAYS,0,0

    test    eax,eax
    jnz     @f
    invoke  crt_printf,ADDR msg2
    jmp     _finish2
@@:
    mov     hFile,eax

    mov     edx,OFFSET buffer
    cmp     DWORD PTR [edx+2],003Ah         ; check if the first parameter
    jne     @f                              ; is a drive symbol
    mov     flag1,1                         ; flag1 = flag to identify the first folder to search
    mov     drv,1
@@:
    invoke  VirtualAlloc,0,\
            MEM_SIZE,MEM_COMMIT,\
            PAGE_READWRITE

    test    eax,eax
    jnz     @f
    invoke  crt_printf,ADDR msg4
    jmp     _finish1
@@:
    mov     hMem,eax

    invoke  SearchDir,ADDR buffer,0

    invoke  VirtualFree,hMem,0,MEM_RELEASE

_finish1:

    invoke  CloseHandle,hFile

_finish2:

    invoke  ExitProcess,0

SearchDir PROC uses esi edi BaseDir:DWORD,DirLevel:DWORD

LOCAL hFind:DWORD
LOCAL wfd:WIN32_FIND_DATAW
LOCAL LastChar:DWORD

    mov     edi,BaseDir                     ; get the base directory
    invoke  UniStrLen,edi                   ; calculate the lenght
    shl     eax,1
    lea     edx,[eax+edi]                   ; find the end of the string
    mov     LastChar,edx                    ; store the address

    cmp     drv,1                           ; is it a drive?
    jne     @f
    mov     DWORD PTR [edx],5Ch
    jmp     ReadPerm
@@:
    cmp     flag1,1
    jne     FindFile

_loop:    

    mov     DWORD PTR [edx],002A005Ch       ; append \*.* ( UNICODE )
    mov     DWORD PTR [edx+4],002A002Eh 
    mov     WORD PTR  [edx+8],0             ; double NULL terminators    

FindFile:

    lea     esi,wfd
    invoke  FindFirstFileW,edi,esi    
    mov     ecx,LastChar
    mov     WORD PTR [ecx],0

    cmp     eax,INVALID_HANDLE_VALUE
    jne     @f
    ret
@@:
    mov     hFind,eax
    cmp     flag1,1
    jne     ReadPerm

CheckFileName:

    lea     eax,WIN32_FIND_DATAW.cFileName[esi]
    cmp     DWORD PTR [eax],2Eh             ; skip symbol .
    je      ProcessNextFile
    cmp     DWORD PTR [eax],002E002Eh       ; skip symbol ..
    je      ProcessNextFile

    mov     edx,LastChar
    mov     DWORD PTR [edx],5Ch
    add     edx,2
    invoke  ucCopy,eax,edx                  ; BaseDir = BaseDir + FileName

ReadPerm:

    invoke  GetFileSecurityW,edi,\
            OWNER_SECURITY_INFORMATION or GROUP_SECURITY_INFORMATION or \
            DACL_SECURITY_INFORMATION or SACL_SECURITY_INFORMATION,\
            hMem,MEM_SIZE,ADDR actualsize
    test    eax,eax
    jnz     @f

    invoke  crt_wprintf,ADDR format1,edi
    mov     ExitSearch,1
    jmp     EndSearch

@@:
    invoke  WriteFile,hFile,\               ; write the length of the security descriptor
            ADDR actualsize,4,ADDR bWritten,0
            
    test    eax,eax
    jnz     @f
    invoke  crt_printf,ADDR msg3
    mov     ExitSearch,1
    jmp     EndSearch
@@:
    invoke  WriteFile,hFile,\               ; write the security descriptor
            hMem,actualsize,ADDR bWritten,0
            
    test    eax,eax
    jnz     @f
    invoke  crt_printf,ADDR msg3
    mov     ExitSearch,1
    jmp     EndSearch
@@:
    mov     edx,LastChar
    mov     ecx,DWORD PTR [edx]
    mov     tmp,ecx
    mov     DWORD PTR [edx],0

    cmp     drv,1
    jne     @f
    
    mov     drv,0
    jmp     _loop
@@:   
    mov     ecx,WIN32_FIND_DATAW.dwFileAttributes[esi]
    and     ecx,000000010h
    cmp     ecx,FILE_ATTRIBUTE_DIRECTORY    ; is it a directory?
    jne     ProcessNextFile

    cmp     flag1,1
    je      @f
    
    mov     flag1,1
    jmp     RecourseSubDir
@@:
    mov     edx,LastChar
    mov     ecx,tmp
    mov     DWORD PTR [edx],ecx

RecourseSubDir:
       
    inc     DirLevel                        ; track recursion level
    invoke  SearchDir,edi,DirLevel          ; go to the subdirectory
    
    cmp     ExitSearch,1
    je      EndSearch
    
    cmp     DirLevel,0                      ; have we reached the base direcory?
    je      ProcessNextFile
    
    dec     DirLevel
    
    mov     edx,LastChar
    mov     BYTE PTR [edx],0  

ProcessNextFile:

    invoke  FindNextFileW,hFind,ADDR wfd
    test    eax,eax
    jnz     CheckFileName

EndSearch:

    invoke  FindClose,hFind

    ret
    
SearchDir ENDP    


GetPrivileges PROC USES esi

LOCAL TokenPriv:TOKEN_PRIVILEGES
LOCAL hToken:DWORD

    invoke  GetCurrentProcess
    lea     ecx,hToken

    invoke  OpenProcessToken,eax,\
                             TOKEN_ADJUST_PRIVILEGES or TOKEN_QUERY,\
                             ecx
    lea     esi,TokenPriv

    invoke  LookupPrivilegeValue,0,ADDR SE_SECURITY_NAME_,\
            ADDR TOKEN_PRIVILEGES.Privileges.Luid[esi]

    mov     TOKEN_PRIVILEGES.PrivilegeCount[esi],1
    mov     TOKEN_PRIVILEGES.Privileges.Attributes[esi],SE_PRIVILEGE_ENABLED

    invoke  AdjustTokenPrivileges,hToken,0,ADDR TokenPriv,0,0,0
    ret

GetPrivileges ENDP


OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

align 4

UniStrLen PROC _str:DWORD

    mov     eax,DWORD PTR [esp+4]
    mov     ecx,2
    sub     eax,ecx
@@:
    add     eax,ecx
    cmp     WORD PTR [eax],0
    jne     @b
    sub     eax,DWORD PTR [esp+4]
    shr     eax,1
    ret     4

UniStrLen ENDP

OPTION PROLOGUE:ProLogueDef
OPTION EPILOGUE:EpilogueDef

END start
